local scdata = require ("scdata")
local A = require("__sc-redux__.anim")

local function add_shield_prototype(unit_name)
  scale = scdata.unit[unit_name].collision[2] / 32
  shield_layers = A.effects_shield(scale)
  
  data:extend({
    {
      type = "sticker",
      name = string.format("protoss-%s-shield-00", unit_name),
      flags = {},
      animation = { layers = shield_layers },
      duration_in_ticks = 8,
      single_particle = true
    }
  })

  for i = 1, 8 do
    data:extend({
      {
        type = "sticker",
        name = string.format("protoss-%s-shield-%02d", unit_name, i),
        flags = {},
        animation = shield_layers[i],
        duration_in_ticks = 8,
        single_particle = true
      }
    })
  end
end

return add_shield_prototype
