local core_util = require("__core__.lualib.util")
local U = require ("__sc-redux__.util")
local C = require ("__sc-redux__.constants")
local A = require ("__sc-redux__.anim")
local scdata = require ("scdata")
local add_shield_prototype = require ("prototypes.entity.effect.shield")
local protoss_util = require("util")

local function add_archon_based_prototype(unit_name, level)
  tierdata = C.TIERDATA[level]
  hm = tierdata.health
  am = tierdata.attack
  tint = tierdata.tint
  uscdat = scdata.unit[unit_name]

  local unit = protoss_util.basic_protoss_unit(unit_name, level)
  unit.icon = "__sc-redux__/graphics/hd/archon/lightning-long.png"
  unit.icon_size = 64
  unit.icon_mipmaps = 4
  unit.collision_mask = { "object-layer" }
  unit.order = string.format("p-b-d-%02d", level)
  unit.attack_parameters = {
    type = "beam",
    source_direction_count = 32,
    source_offset = { 999, 999 },
    range = 5 * uscdat.range,
    cooldown = uscdat.cooldown / 0.4,
    cooldown_deviation = 0.05,
    warmup = 0,
    damage_modifier = 0.01,
    ammo_type = {
      category = "laser",
      action = {
        type = "direct",
        action_delivery = {
          type = "beam",
          beam = "laser-beam", --string.format("archon-lightning-%02d", level),
          max_length = 24,
          duration = 30,
          source_offset = { 0, 0 }
        }
      }
    },
    animation = A.archon_attack(),
    range_mode = "center-to-center"
  }
  unit.dying_sound = { filename = "__protoss-redux__/sound/dragoon/pdrdth00.wav" }
  unit.run_animation = {
    layers = {
      A.archon_run()
    }
  }
  unit.distance_per_frame = 3

  data:extend({unit})
  data:extend({
    {
      type = "beam",
      name = string.format("archon-lightning-%02d", level),
      flags = {"not-on-map"},
      width = 100,
      damage_interval = 30,
      random_target_offset = false,
      action_triggered_automatically = false,
      action = {
        type = "direct",
        action_delivery = {
          type = "instant",
          target_effects = {
            {
              type = "damage",
              damage = { amount = uscdat.damage * am, type = "physical" }
            }
          }
        }
      },
      start = {
        layers = {
          A.archon_lightning_long(),
          --A.archon_psionic_shockwave()
        }
      },
      head = core_util.empty_sprite(18),
      body = core_util.empty_sprite(18),
      tail = core_util.empty_sprite(18),
    }
  })
end

for i = 1, 4 do add_archon_based_prototype("archon", i) end
add_shield_prototype("archon")

