local scdata = require ("scdata")

function create_shield(e, unit_name)
  entity = e.entity
  uscdat = scdata.unit[unit_name]
  if entity.get_health_ratio() < uscdat.health / (uscdat.shield + uscdat.health) then return end
  cause = e.cause
  if cause and e.damage_type.name ~= "fire" then
    theta = math.atan2(cause.position.x - entity.position.x, entity.position.y - cause.position.y)
    direction = math.floor(theta * 4 / math.pi + 0.5) % 8 + 1
  else
    direction = math.floor(math.random() * 8) + 1
  end

  sticker_name = string.format("protoss-%s-shield-%02d", unit_name, direction)
  stickers = entity.stickers or {}
  for _, sticker in ipairs(stickers) do
    if sticker.name == sticker_name then return end
  end
  entity.surface.create_entity{
    name = sticker_name,
    position = entity.position,
    target = entity
  }
end

script.on_event(
defines.events.on_entity_damaged,
function(e)
  entity_name = e.entity.name
  if string.sub(entity_name, 1, 7) ~= "protoss" then return end
  unit_name = string.sub(entity_name, 9, -4)
  create_shield(e, unit_name)
end,
{}
)

-- create_shield_event("protoss-dragoon-03", 12.5 * 100)
