local sc_util = require("__sc-redux__.util")
local sc_constants = require("__sc-redux__.constants")
local protoss_constants = require("scdata")

return {
  basic_protoss_unit = function(sc_unit_name, level)
    local unit = sc_util.create_base_unit()
    local unit_constants = protoss_constants.unit[sc_unit_name]
    local tierdata = sc_constants.TIERDATA[level]
    
    unit.name = string.format("protoss-%s-%02d", sc_unit_name, level)
    unit.max_health = tierdata.health * (unit_constants.health + unit_constants.shield)
    unit.resistances = {}
    unit.healing_per_tick = tierdata.health * unit_constants.shield / (unit_constants.health + unit_constants.shield) * protoss_constants.shield_regen
    unit.collision_box = {
      {-uscdat.collision[1]/32, -uscdat.collision[2]/32},
      {uscdat.collision[1]/32, uscdat.collision[2]/32}
    }
    unit.selection_box = {
      {-uscdat.collision[1]/32, -uscdat.collision[2]/32},
      {uscdat.collision[1]/32, uscdat.collision[2]/32}
    }
    unit.vision_distance = 30
    unit.movement_speed = unit_constants.movement * sc_constants.MOVEMENT_MULTIPLIER
    unit.pollution_to_join_attack = 4
    unit.distraction_cooldown = 300
    unit.min_pursue_time = 10 * 60
    unit.max_pursue_distance = 50
    
    return unit
  end
}
